"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
const hmc_win32_1 = __importDefault(require("hmc-win32"));
exports.config = {
    name: 'clipboard.getClipboardText',
    icon: 'icon-web-create',
    displayName: '读取剪贴板中的文本',
    comment: '读取剪贴板中的文本',
    inputs: {},
    outputs: {
        clipboardText: {
            name: '',
            display: '字符串-粘贴板文本内容',
            type: 'string',
            addConfig: {
                label: '粘贴板文本内容',
                type: 'variable',
                defaultValue: 'clipboardText'
            }
        }
    }
};
const impl = function () {
    return __awaiter(this, void 0, void 0, function* () {
        const clipboardText = hmc_win32_1.default.getClipboardText();
        return { clipboardText };
    });
};
exports.impl = impl;
