"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: 'dataProcessing.logPrint',
    displayName: '输出日志',
    icon: 'icon-web-create',
    isControl: false,
    isControlEnd: false,
    comment: '输出 ${level} 级别日志 , 内容: ${content}',
    inputs: {
        level: {
            name: 'level',
            value: '',
            display: '信息',
            type: 'string',
            addConfig: {
                required: true,
                label: '日志输出类型',
                type: 'select',
                options: [
                    {
                        label: '信息',
                        value: 'info'
                    },
                    {
                        label: '调试',
                        value: 'debug'
                    },
                    {
                        label: '警告',
                        value: 'warn'
                    },
                    {
                        label: '错误',
                        value: 'error'
                    }
                ],
                defaultValue: 'info',
                tip: '日志输出级别'
            }
        },
        content: {
            name: '要输出的内容',
            value: '',
            type: 'string',
            addConfig: {
                label: '输出内容',
                placeholder: '请输入要输出的内容',
                type: 'textarea',
                defaultValue: '',
                tip: '输出内容'
            }
        }
    },
    outputs: {}
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ content, level }) {
        switch (level) {
            case 'info':
                console.info(content);
                break;
            case 'debug':
                console.debug(content);
                break;
            case 'warn':
                console.warn(content);
                break;
            case 'error':
                console.error(content);
                break;
            default:
                console.log(content);
                break;
        }
    });
};
exports.impl = impl;
