"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: "dataProcessing.map.forMap",
    isControl: true,
    isLoop: true,
    isControlEnd: false,
    displayName: "循环Map数据",
    comment: "循环Map数据 ${mapObj}",
    inputs: {
        mapObj: {
            name: "mapObj",
            value: "",
            display: "",
            type: "variable",
            addConfig: {
                required: true,
                label: "Map对象",
                placeholder: "选择Map对象",
                type: "variable",
                filtersType: "map",
                autoComplete: true,
            },
        },
    },
    outputs: {
        key: {
            name: "key",
            type: "string",
            display: "Map键",
            addConfig: {
                required: true,
                type: "variable",
                label: "Map键",
            },
        },
        value: {
            name: "value",
            type: "string",
            display: "Map值",
            addConfig: {
                required: true,
                type: "variable",
                label: "Map键",
            },
        },
    },
    toCode(directive, block) {
        return __awaiter(this, void 0, void 0, function* () {
            const { mapObj } = directive.inputs;
            const { key, value } = directive.outputs;
            const code = `for (const [${key.name}, ${value.name}] of await robotUtil.system.dataProcessing.map.forMap(${mapObj.value},${block})) {`;
            return code;
        });
    },
};
const impl = function (mapObj) {
    return __awaiter(this, void 0, void 0, function* () {
        return mapObj.entries();
    });
};
exports.impl = impl;
