"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const fs = require("fs");
exports.config = {
    name: "dataProcessing.setVariable",
    displayName: "设置变量",
    isControl: false,
    isControlEnd: false,
    comment: "设置${varType}变量 ${varName} 值为 ${varValue}",
    inputs: {
        varType: {
            name: "变量类型",
            value: "",
            display: "",
            type: "string",
            addConfig: {
                label: "变量类型",
                type: "select",
                required: true,
                defaultValue: "string",
                tip: "选择变量类型",
                options: [
                    {
                        label: "文本",
                        value: "string",
                    },
                    {
                        label: "数字",
                        value: "number",
                    },
                    {
                        label: "json对象",
                        value: "jsonObj",
                    },
                    {
                        label: "任意对象",
                        value: "any",
                    },
                ],
            },
        },
        varValue: {
            name: "变量值",
            value: "",
            type: "string",
            addConfig: {
                label: "变量值",
                type: "string",
                defaultValue: "",
            },
        },
    },
    outputs: {
        varName: {
            name: "",
            type: "string",
            display: "字符串",
            addConfig: {
                label: "变量名",
                type: "variable",
                defaultValue: "variable",
            },
        },
    },
};
exports.impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ varType, varValue }) {
        let varName = varValue;
        if (varType === "number") {
            varName = Number(varValue);
        }
        if (varType === "jsonObj") {
            try {
                varName = JSON.parse(varValue);
            }
            catch (error) {
                throw new Error("json对象格式错误");
            }
        }
        return { varName };
    });
};
