"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: "excel.getSheets",
    displayName: "获取Excel的所有个工作表",
    icon: "icon-web-create",
    isControl: false,
    isControlEnd: false,
    comment: "从workbook对象读取一个工作表，并保存到${sheet}。",
    inputs: {
        workbook: {
            name: "workbook",
            value: "",
            type: "variable",
            addConfig: {
                required: true,
                label: "excel对象",
                type: "variable",
                filtersType: "excel.workbook",
                autoComplete: true,
            },
        },
    },
    outputs: {
        sheets: {
            name: "",
            display: "工作表对象",
            type: "array",
            addConfig: {
                label: "所有工作表对象",
                type: "variable",
                defaultValue: "sheets",
            },
        },
    },
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ workbook }) {
        const sheets = [];
        workbook.SheetNames.forEach((sheetName) => {
            sheets.push(workbook.Sheets[sheetName]);
        });
        return { sheets };
    });
};
exports.impl = impl;
