"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
const xlsx_1 = __importDefault(require("xlsx"));
exports.config = {
    name: "excel.read",
    displayName: "读取Excel表格",
    icon: "icon-web-create",
    isControl: false,
    isControlEnd: false,
    comment: "读取一个表格文件${filePath}，保存到变量${workbook}。",
    inputs: {
        filePath: {
            name: "filePath",
            value: "",
            type: "string",
            addConfig: {
                required: true,
                placeholder: "请输入文件路径",
                label: "表格文件路径",
                extensions: ["xlsx", "xls"],
                type: "filePath",
                defaultValue: "",
                tip: "选择表格文件路径",
            },
        },
    },
    outputs: {
        workbook: {
            name: "",
            display: "Excel对象-包含多个工作表",
            type: "excel.workbook",
            addConfig: {
                label: "Excel对象",
                type: "variable",
                defaultValue: "workbook",
            },
        },
    },
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ filePath }) {
        const workbook = xlsx_1.default.readFile(filePath);
        // if (!workbook.Sheets[sheetName]) {
        // 	throw new Error(`工作表${sheetName}不存在`);
        // }
        // const sheet = workbook.Sheets[sheetName];
        return { workbook };
    });
};
exports.impl = impl;
