"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
const xlsx_1 = __importDefault(require("xlsx"));
exports.config = {
    name: "excel.saveExcel",
    displayName: "保存Excel表格",
    icon: "icon-web-create",
    isControl: false,
    isControlEnd: false,
    comment: "将${workbook},保存到文件${filePath}",
    inputs: {
        workbook: {
            name: "workbook",
            value: "",
            type: "variable",
            addConfig: {
                required: true,
                label: "excel对象",
                type: "variable",
                filtersType: "excel.workbook",
                autoComplete: true,
            },
        },
        filePath: {
            name: "filePath",
            value: "",
            type: "string",
            addConfig: {
                required: true,
                placeholder: "保存的文件路径，例如：c:/test.xlsx",
                label: "文件路径",
                type: "filePath",
                defaultValue: "",
                tip: "保存的文件路径",
            },
        },
    },
    outputs: {},
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ workbook, filePath, }) {
        // const file = join(filePath);
        // if (!fs.existsSync(file)) {
        // 	fs.mkdirSync(file.slice(0, file.lastIndexOf("/")), { recursive: true });
        // }
        xlsx_1.default.writeFile(workbook, filePath);
        return { workbook };
    });
};
exports.impl = impl;
