"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
const xlsx_1 = __importDefault(require("xlsx"));
exports.config = {
    name: "excel.setCellValue",
    displayName: "设置单元格值",
    icon: "icon-web-create",
    isControl: false,
    isControlEnd: false,
    comment: "将值${val}写入单元格 行号${rowNum}列号${colNum}",
    inputs: {
        sheet: {
            name: "sheet",
            value: "",
            type: "variable",
            addConfig: {
                required: true,
                label: "工作表",
                type: "variable",
                filtersType: "excel.sheet",
                autoComplete: true,
            },
        },
        rowNum: {
            name: "rowNum",
            value: "",
            type: "number",
            addConfig: {
                required: true,
                label: "设置单元格的行号",
                placeholder: "请输入行号",
                type: "string",
                defaultValue: "",
            },
        },
        colNum: {
            name: "colNum",
            value: "",
            type: "number",
            addConfig: {
                required: true,
                label: "设置单元格的列号",
                placeholder: "请输入列号",
                type: "string",
                defaultValue: "",
            },
        },
        val: {
            name: "val",
            value: "",
            type: "string",
            addConfig: {
                required: true,
                label: "要写入的文本内容",
                type: "textarea",
                defaultValue: "",
            },
        },
    },
    outputs: {},
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ sheet, rowNum, colNum, val, }) {
        const cellAddress = xlsx_1.default.utils.encode_cell({
            r: rowNum - 1,
            c: colNum - 1,
        });
        sheet[cellAddress] = {
            v: val,
            t: "s",
        };
    });
};
exports.impl = impl;
