"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: 'flowApp.addSubFlowReturnVal',
    displayName: '子流程添加返回值',
    icon: 'icon-web-create',
    isControl: false,
    isControlEnd: false,
    comment: '添加返回值${val}到返回值列表中',
    inputs: {
        val: {
            name: 'val',
            value: '',
            type: 'array',
            addConfig: {
                label: '添加要返回的变量列表',
                type: 'variable',
                multiple: true,
                required: true,
                tip: '添加要返回的内容'
            }
        }
    },
    outputs: {},
    toCode(directive, block) {
        return __awaiter(this, void 0, void 0, function* () {
            const { val } = directive.inputs;
            return `await robotUtil.system.flowApp.addSubFlowReturnVal({val: [${val.value}] },_returnVal,${block})`;
        });
    }
};
const impl = function (_a, returnVal_1) {
    return __awaiter(this, arguments, void 0, function* ({ val }, returnVal) {
        returnVal.push(...val);
    });
};
exports.impl = impl;
