"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
const fs = require("fs");
exports.config = {
    name: 'flowControl.exit',
    displayName: '终止流程',
    icon: 'icon-web-create',
    sort: 40,
    isControl: false,
    isControlEnd: false,
    comment: '停止流程后续的所有操作并结束',
    inputs: {},
    outputs: {},
    toCode(_directive, block) {
        return __awaiter(this, void 0, void 0, function* () {
            return `await robotUtil.system.flowControl.exit(${block})`;
        });
    }
};
exports.impl = function () {
    return __awaiter(this, void 0, void 0, function* () {
        console.log('终止流程');
        process.exit();
    });
};
