"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
const hmc_win32_1 = __importDefault(require("hmc-win32"));
const config = {
    name: 'keyboard.sendKeyCode1',
    displayName: '发送一次完整按键（按下+松开）',
    icon: 'icon-web-create',
    isControl: false,
    isControlEnd: false,
    comment: '发送键盘按键 ${keyCode} 按下 ${time} 毫秒后松开 ',
    inputs: {
        keyCode: {
            name: 'keyCode',
            value: 'A',
            type: 'string',
            addConfig: {
                placeholder: '请输入需要发送的键值',
                required: true,
                label: '键值',
                type: 'string'
            }
        },
        time: {
            name: 'time',
            value: '',
            type: 'number',
            addConfig: {
                placeholder: '请输入按键持续时间（单位：毫秒）',
                required: true,
                label: '按下持续时间',
                type: 'string',
                defaultValue: '0'
            }
        }
    },
    outputs: {}
};
exports.config = config;
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ keyCode, time }) {
        hmc_win32_1.default.sendKeyboard(keyCode, true);
        yield new Promise((resolve) => setTimeout(resolve, time));
        hmc_win32_1.default.sendKeyboard(keyCode, false);
    });
};
exports.impl = impl;
