"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: "text.appendText",
    icon: "icon-web-create",
    displayName: "追加文本内容",
    comment: "原始${text}文本后面追加${appendText}文本,并保存结果至${result}",
    inputs: {
        text: {
            name: "text",
            value: "",
            display: "",
            type: "string",
            addConfig: {
                label: "原始文本",
                placeholder: "原始文本",
                type: "textarea",
                required: true,
            },
        },
        appendText: {
            name: "appendText",
            value: "",
            display: "",
            type: "string",
            addConfig: {
                label: "追加文本",
                placeholder: "追加文本",
                type: "textarea",
                required: true,
            },
        },
    },
    outputs: {
        result: {
            name: "",
            display: "保存结果至",
            type: "string",
            addConfig: {
                label: "保存结果至",
                type: "variable",
                defaultValue: "result",
            },
        },
    },
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ text, appendText, }) {
        return { result: text.concat(appendText) };
    });
};
exports.impl = impl;
