"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: "text.getTextLenth",
    icon: "icon-web-create",
    displayName: "获取文本长度",
    comment: "获取${text}文本的长度，并将结果保存到变量${textLength}中",
    inputs: {
        text: {
            name: "text",
            value: "",
            display: "",
            type: "string",
            addConfig: {
                label: "文本内容",
                placeholder: "文本内容",
                type: "textarea",
                required: true,
            },
        },
    },
    outputs: {
        textLength: {
            name: "",
            display: "文本长度",
            type: "string",
            addConfig: {
                label: "文本长度",
                type: "variable",
                defaultValue: "textLength",
            },
        },
    },
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ text }) {
        const textLength = text ? text.length : 0;
        return { textLength };
    });
};
exports.impl = impl;
