"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: 'web.cssNoNeedGetElementList',
    sort: 2,
    displayName: 'CSS或XPath无需等待获取元素列表',
    icon: 'icon-web-create',
    isControl: false,
    isControlEnd: false,
    comment: '在页面对象${browserPage}中，使用CSS或XPath选择器${selector}查找元素列表，无需等待获取元素。返回元素对象列表${webElement}。',
    inputs: {
        browserPage: {
            name: 'browserPage',
            value: '',
            display: '',
            type: 'variable',
            addConfig: {
                label: '网页对象',
                type: 'variable',
                filtersType: 'web.page',
                autoComplete: true
            }
        },
        selector: {
            name: 'selector',
            value: '',
            display: '',
            type: 'string',
            addConfig: {
                required: true,
                label: 'CSS或XPath选择器',
                type: 'textarea'
            }
        }
    },
    outputs: {
        webElementList: {
            name: '',
            display: '元素对象列表',
            type: 'array',
            addConfig: {
                label: '元素对象列表',
                type: 'variable',
                defaultValue: 'webElementList'
            }
        }
    }
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ browserPage, selector }) {
        if (selector.startsWith('//')) {
            selector = `::-p-xpath(${selector})`;
        }
        let webElementList = yield browserPage.$$(selector);
        return { webElementList: webElementList ? webElementList : '' };
    });
};
exports.impl = impl;
