"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
const config = {
    name: 'web.fileSelect',
    sort: 2,
    displayName: '选择文件',
    icon: 'icon-web-create',
    isControl: false,
    isControlEnd: false,
    comment: '在页面${page}选择文件',
    inputs: {
        page: {
            name: 'page',
            value: '',
            display: '',
            type: 'variable',
            addConfig: {
                label: '浏览器对象',
                required: true,
                type: 'variable',
                filtersType: 'web.browser',
                autoComplete: true
            }
        }
    },
    outputs: {
        filePath: {
            name: '',
            display: '文件路径',
            type: 'string',
            addConfig: {
                label: '文件路径',
                type: 'variable',
                defaultValue: 'filePath'
            }
        }
    }
};
exports.config = config;
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ page }) {
        const str = yield page.evaluate(() => {
            return new Promise((resolve) => {
                const input = document.createElement('input');
                input.type = 'file';
                input.click();
                input.onchange = (e) => {
                    console.log(e.target.files[0]);
                    resolve(input.value);
                };
            });
        });
        console.log('选择的文件路径：', str);
        return { filePath: str };
    });
};
exports.impl = impl;
