"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: 'web.getElementProperty',
    sort: 2,
    displayName: '获取元素属性',
    icon: 'icon-web-create',
    isControl: false,
    isControlEnd: false,
    comment: '获取元素${selector}的属性${propertyName}的值, 并将其赋值给变量${propertyValue}',
    inputs: {
        element: {
            name: 'element',
            value: '',
            display: '',
            type: 'variable',
            addConfig: {
                label: '选择元素对象',
                type: 'variable',
                filtersType: 'web.element',
                autoComplete: true
            }
        },
        propertyName: {
            name: 'propertyName',
            value: '',
            display: '文本内容',
            type: 'string',
            addConfig: {
                required: true,
                label: '选择获取的属性',
                type: 'select',
                options: [
                    {
                        label: '文本内容',
                        value: 'innerText'
                    },
                    {
                        label: 'html内容',
                        value: 'innerHTML'
                    },
                    {
                        label: 'src属性',
                        value: 'src'
                    }
                ],
                defaultValue: 'innerText',
                tip: '获取的属性的值'
            }
        }
    },
    outputs: {
        propertyValue: {
            name: '',
            display: '字符串-元素属性值',
            type: 'string',
            addConfig: {
                label: '属性值',
                type: 'variable',
                defaultValue: 'webElementProperty'
            }
        }
    }
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ element, propertyName }) {
        const propertyValue = yield element.getProperty(propertyName);
        return {
            propertyValue: yield propertyValue.jsonValue()
        };
    });
};
exports.impl = impl;
