"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
const config = {
    name: 'web.keyboardInput',
    sort: 2,
    displayName: '键盘输入',
    icon: 'icon-web-create',
    isControl: false,
    isControlEnd: false,
    comment: '在页面${page}中，选择元素${selector}上按下键盘${keyboardKey}，超时时间${timeout}秒',
    inputs: {
        page: {
            name: 'page',
            value: '',
            display: '',
            type: 'variable',
            addConfig: {
                label: '网页对象',
                type: 'variable',
                filtersType: 'web.page',
                autoComplete: true
            }
        },
        selector: {
            name: 'selector',
            value: '',
            display: '',
            type: 'string',
            addConfig: {
                label: 'css选择器',
                required: true,
                type: 'string'
            }
        },
        keyboardKey: {
            name: 'keyboardKey',
            value: '',
            type: 'string',
            addConfig: {
                required: true,
                label: '选择键盘按下的键',
                type: 'select',
                options: [
                    {
                        label: '0',
                        value: '0'
                    },
                    {
                        label: '1',
                        value: '1'
                    },
                    {
                        label: '2',
                        value: '2'
                    },
                    {
                        label: '3',
                        value: '3'
                    },
                    {
                        label: '4',
                        value: '4'
                    },
                    {
                        label: '5',
                        value: '5'
                    },
                    {
                        label: '6',
                        value: '6'
                    },
                    {
                        label: '7',
                        value: '7'
                    },
                    {
                        label: '8',
                        value: '8'
                    },
                    {
                        label: '9',
                        value: '9'
                    },
                    {
                        label: 'Enter',
                        value: 'Enter'
                    },
                    {
                        label: 'Power',
                        value: 'Power'
                    },
                    {
                        label: 'Eject',
                        value: 'Eject'
                    },
                    {
                        label: 'Abort',
                        value: 'Abort'
                    },
                    {
                        label: 'Help',
                        value: 'Help'
                    },
                    {
                        label: 'Tab',
                        value: 'Tab'
                    },
                    {
                        label: 'Backspace',
                        value: 'Backspace'
                    },
                    {
                        label: 'Numpad5',
                        value: 'Numpad5'
                    },
                    {
                        label: 'NumpadEnter',
                        value: 'NumpadEnter'
                    },
                    {
                        label: 'ShiftLeft',
                        value: 'ShiftLeft'
                    },
                    {
                        label: 'ShiftRight',
                        value: 'ShiftRight'
                    }
                ]
            }
        },
        timeout: {
            name: 'timeout',
            value: '',
            type: 'number',
            addConfig: {
                isAdvanced: true,
                label: '超时时间',
                type: 'string',
                defaultValue: 30
            }
        }
    },
    outputs: {}
};
exports.config = config;
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ page, selector, keyboardKey, timeout }) {
        const elementHandle = yield page.waitForSelector(selector, {
            timeout: timeout * 1000
        });
        if (!elementHandle) {
            throw new Error(`元素${selector}未找到`);
        }
        yield elementHandle.press(keyboardKey);
    });
};
exports.impl = impl;
