"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: 'web.mouseClick',
    icon: 'icon-web-create',
    displayName: '鼠标点击',
    comment: '在页面${page}中，坐标(${x}, ${y})处 单击${count}次',
    inputs: {
        page: {
            name: 'page',
            value: '',
            display: '',
            type: 'variable',
            addConfig: {
                label: '标签页对象',
                placeholder: '请输入标签页对象',
                type: 'variable',
                filtersType: 'web.page',
                autoComplete: true
            }
        },
        x: {
            name: 'x',
            value: '',
            display: '',
            type: 'number',
            addConfig: {
                placeholder: '请输入鼠标的水平位置 例如：100',
                label: '鼠标的水平位置',
                type: 'string'
            }
        },
        y: {
            name: 'y',
            value: '',
            display: '',
            type: 'number',
            addConfig: {
                placeholder: '请输入鼠标的垂直位置 例如：100',
                label: '鼠标的垂直位置',
                type: 'string'
            }
        },
        count: {
            name: 'count',
            value: '',
            display: '',
            type: 'number',
            addConfig: {
                label: '点击次数',
                type: 'string',
                placeholder: '请输入单击次数 例如：1、2、3',
                defaultValue: '1'
            }
        }
    },
    outputs: {}
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ page, x, y, count }) {
        yield page.mouse.click(x, y, { count });
    });
};
exports.impl = impl;
