"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: 'web.mouseMove',
    icon: 'icon-web-create',
    displayName: '移动鼠标',
    comment: '在页面${page}中，移动鼠标到坐标${x},${y}',
    inputs: {
        page: {
            name: 'page',
            value: '',
            display: '',
            type: 'variable',
            addConfig: {
                label: '标签页对象',
                type: 'variable',
                filtersType: 'web.page',
                autoComplete: true
            }
        },
        x: {
            name: 'x',
            value: '',
            display: '',
            type: 'number',
            addConfig: {
                label: '水平位置X坐标',
                type: 'string'
            }
        },
        y: {
            name: 'y',
            value: '',
            display: '',
            type: 'number',
            addConfig: {
                label: '垂直位置Y坐标',
                type: 'string'
            }
        }
    },
    outputs: {}
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ page, x, y }) {
        console.log('move mouse to x: ' + x + ' y: ' + y);
        yield page.mouse.move(x, y);
    });
};
exports.impl = impl;
