"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: 'web.mouseWheel',
    icon: 'icon-web-create',
    displayName: '鼠标滚轮',
    comment: '在页面${page}中，水平滚动${deltaX}像素，垂直滚动${deltaY}像素。',
    inputs: {
        page: {
            name: 'page',
            value: '',
            display: '',
            type: 'variable',
            addConfig: {
                label: '标签页对象',
                placeholder: '请输入标签页对象',
                type: 'variable',
                filtersType: 'web.page',
                autoComplete: true
            }
        },
        deltaX: {
            name: 'deltaX',
            value: '',
            display: '',
            type: 'number',
            addConfig: {
                placeholder: '滚轮的水平偏移量 例如：100 单位：像素',
                label: 'X方向滚动距离',
                type: 'string'
            }
        },
        deltaY: {
            name: 'deltaY',
            value: '',
            display: '',
            type: 'number',
            addConfig: {
                placeholder: '滚轮的垂直偏移量 例如：100 单位：像素',
                label: 'Y方向滚动距离',
                type: 'string'
            }
        }
    },
    outputs: {}
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ page, deltaX, deltaY }) {
        yield page.mouse.wheel({ deltaX, deltaY });
    });
};
exports.impl = impl;
