"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: 'web.pageScreenshotSaveFile',
    icon: 'icon-web-create',
    displayName: '页面中元素截图保存到本地',
    comment: '在页面${browserPage}中选中元素${selector}，并对其进行截图，并保存到本地${fileSavePath}。',
    inputs: {
        browserPage: {
            name: 'browserPage',
            value: '',
            display: '',
            type: 'variable',
            addConfig: {
                label: '标签页对象',
                type: 'variable',
                filtersType: 'web.page',
                autoComplete: true
            }
        },
        selector: {
            name: 'selector',
            value: '',
            display: '',
            type: 'string',
            addConfig: {
                label: 'css选择器',
                placeholder: '不填写则默认截取整个页面',
                type: 'string',
                defaultValue: '',
                tip: '不填写则默认截取整个页面'
            }
        },
        fileSavePath: {
            name: 'fileSavePath',
            value: '',
            display: '',
            type: 'string',
            addConfig: {
                label: '文件保存路径',
                placeholder: '选择要文件保存路径',
                type: 'filePath',
                defaultValue: '',
                required: true,
                openDirectory: true,
                tip: '文件保存路径'
            }
        }
    },
    outputs: {}
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ browserPage, selector, fileSavePath }) {
        if (selector) {
            const fileElement = yield browserPage.waitForSelector(selector);
            if (fileElement) {
                yield fileElement.screenshot({
                    path: fileSavePath + '/' + new Date().getTime() + '.png'
                });
            }
        }
        else {
            yield browserPage.screenshot({
                path: fileSavePath + '/' + new Date().getTime() + '.png',
                fullPage: true
            });
        }
        console.log('截图保存成功！');
    });
};
exports.impl = impl;
