"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.impl = exports.config = void 0;
exports.config = {
    name: 'web.setCookie',
    icon: 'icon-web-create',
    displayName: '设置cookie',
    comment: '在页面${browserPage}中设置cookie : ${cookie}。',
    inputs: {
        browserPage: {
            name: 'browserPage',
            value: '',
            display: '',
            type: 'variable',
            addConfig: {
                required: true,
                label: '标签页对象',
                placeholder: '选择标签页对象',
                type: 'variable',
                filtersType: 'web.page',
                autoComplete: true
            }
        },
        cookie: {
            name: 'cookie',
            value: '',
            display: '',
            type: 'string',
            addConfig: {
                required: true,
                label: 'cookie字符串',
                placeholder: '输入cookie字符串，例如: a=b; c=d',
                type: 'textarea'
            }
        },
        domain: {
            name: 'domain',
            value: '',
            display: '',
            type: 'string',
            addConfig: {
                label: '域名',
                placeholder: '请输入域名',
                type: 'string',
                defaultValue: ''
            }
        }
    },
    outputs: {}
};
const impl = function (_a) {
    return __awaiter(this, arguments, void 0, function* ({ browserPage, cookie, domain }) {
        const cookies = [];
        cookie.split(';').forEach((item) => {
            const [key, value] = item.split('=');
            if (domain) {
                cookies.push({
                    name: key.trim(),
                    value: value,
                    domain: domain
                });
            }
            else {
                cookies.push({
                    name: key.trim(),
                    value: value
                });
            }
        });
        yield browserPage.setCookie(...cookies);
    });
};
exports.impl = impl;
