"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.keyCodeMap = void 0;
exports.getKeyCodeMap = getKeyCodeMap;
exports.keyCodeMap = [
    {
        value: '0',
        label: '0 - 数字0'
    },
    {
        value: '1',
        label: '1 - 数字1'
    },
    {
        value: '2',
        label: '2 - 数字2'
    },
    {
        value: '3',
        label: '3 - 数字3'
    },
    {
        value: '4',
        label: '4 - 数字4'
    },
    {
        value: '5',
        label: '5 - 数字5'
    },
    {
        value: '6',
        label: '6 - 数字6'
    },
    {
        value: '7',
        label: '7 - 数字7'
    },
    {
        value: '8',
        label: '8 - 数字8'
    },
    {
        value: '9',
        label: '9 - 数字9'
    },
    {
        value: 'Power',
        label: 'Power - 电源'
    },
    {
        value: 'Eject',
        label: 'Eject - 弹出'
    },
    {
        value: 'Abort',
        label: 'Abort - 终止'
    },
    {
        value: 'Help',
        label: 'Help - 帮助'
    },
    {
        value: 'Backspace',
        label: 'Backspace - 退格'
    },
    {
        value: 'Tab',
        label: 'Tab - 制表符'
    },
    {
        value: 'Numpad5',
        label: 'Numpad5 - 小键盘5'
    },
    {
        value: 'NumpadEnter',
        label: 'NumpadEnter - 小键盘回车'
    },
    {
        value: 'Enter',
        label: 'Enter - 回车'
    },
    {
        value: '\r',
        label: '\r - 回车'
    },
    {
        value: '\n',
        label: '\n - 换行'
    },
    {
        value: 'ShiftLeft',
        label: 'ShiftLeft - 左移位'
    },
    {
        value: 'ShiftRight',
        label: 'ShiftRight - 右移位'
    },
    {
        value: 'ControlLeft',
        label: 'ControlLeft - 左控制'
    },
    {
        value: 'ControlRight',
        label: 'ControlRight - 右控制'
    },
    {
        value: 'AltLeft',
        label: 'AltLeft - 左Alt'
    },
    {
        value: 'AltRight',
        label: 'AltRight - 右Alt'
    },
    {
        value: 'Pause',
        label: 'Pause - 暂停'
    },
    {
        value: 'CapsLock',
        label: 'CapsLock - 大写锁定'
    },
    {
        value: 'Escape',
        label: 'Escape - 退出'
    },
    {
        value: 'Convert',
        label: 'Convert - 转换'
    },
    {
        value: 'NonConvert',
        label: 'NonConvert - 不转换'
    },
    {
        value: 'Space',
        label: 'Space - 空格'
    },
    {
        value: 'Numpad9',
        label: 'Numpad9 - 小键盘9'
    },
    {
        value: 'PageUp',
        label: 'PageUp - 上一页'
    },
    {
        value: 'Numpad3',
        label: 'Numpad3 - 小键盘3'
    },
    {
        value: 'PageDown',
        label: 'PageDown - 下一页'
    },
    {
        value: 'End',
        label: 'End - 结束'
    },
    {
        value: 'Numpad1',
        label: 'Numpad1 - 小键盘1'
    },
    {
        value: 'Home',
        label: 'Home - 首页'
    },
    {
        value: 'Numpad7',
        label: 'Numpad7 - 小键盘7'
    },
    {
        value: 'ArrowLeft',
        label: 'ArrowLeft - 左箭头'
    },
    {
        value: 'Numpad4',
        label: 'Numpad4 - 小键盘4'
    },
    {
        value: 'Numpad8',
        label: 'Numpad8 - 小键盘8'
    },
    {
        value: 'ArrowUp',
        label: 'ArrowUp - 上箭头'
    },
    {
        value: 'ArrowRight',
        label: 'ArrowRight - 右箭头'
    },
    {
        value: 'Numpad6',
        label: 'Numpad6 - 小键盘6'
    },
    {
        value: 'Numpad2',
        label: 'Numpad2 - 小键盘2'
    },
    {
        value: 'ArrowDown',
        label: 'ArrowDown - 下箭头'
    },
    {
        value: 'Select',
        label: 'Select - 选择'
    },
    {
        value: 'Open',
        label: 'Open - 打开'
    },
    {
        value: 'PrintScreen',
        label: 'PrintScreen - 打印屏幕'
    },
    {
        value: 'Insert',
        label: 'Insert - 插入'
    },
    {
        value: 'Numpad0',
        label: 'Numpad0 - 小键盘0'
    },
    {
        value: 'Delete',
        label: 'Delete - 删除'
    },
    {
        value: 'NumpadDecimal',
        label: 'NumpadDecimal - 小数点'
    },
    {
        value: 'Digit0',
        label: 'Digit0 - 数字0'
    },
    {
        value: 'Digit1',
        label: 'Digit1 - 数字1'
    },
    {
        value: 'Digit2',
        label: 'Digit2 - 数字2'
    },
    {
        value: 'Digit3',
        label: 'Digit3 - 数字3'
    },
    {
        value: 'Digit4',
        label: 'Digit4 - 数字4'
    },
    {
        value: 'Digit5',
        label: 'Digit5 - 数字5'
    },
    {
        value: 'Digit6',
        label: 'Digit6 - 数字6'
    },
    {
        value: 'Digit7',
        label: 'Digit7 - 数字7'
    },
    {
        value: 'Digit8',
        label: 'Digit8 - 数字8'
    },
    {
        value: 'Digit9',
        label: 'Digit9 - 数字9'
    },
    {
        value: 'KeyA',
        label: 'KeyA - A'
    },
    {
        value: 'KeyB',
        label: 'KeyB - B'
    },
    {
        value: 'KeyC',
        label: 'KeyC - C'
    },
    {
        value: 'KeyD',
        label: 'KeyD - D'
    },
    {
        value: 'KeyE',
        label: 'KeyE - E'
    },
    {
        value: 'KeyF',
        label: 'KeyF - F'
    },
    {
        value: 'KeyG',
        label: 'KeyG - G'
    },
    {
        value: 'KeyH',
        label: 'KeyH - H'
    },
    {
        value: 'KeyI',
        label: 'KeyI - I'
    },
    {
        value: 'KeyJ',
        label: 'KeyJ - J'
    },
    {
        value: 'KeyK',
        label: 'KeyK - K'
    },
    {
        value: 'KeyL',
        label: 'KeyL - L'
    },
    {
        value: 'KeyM',
        label: 'KeyM - M'
    },
    {
        value: 'KeyN',
        label: 'KeyN - N'
    },
    {
        value: 'KeyO',
        label: 'KeyO - O'
    },
    {
        value: 'KeyP',
        label: 'KeyP - P'
    },
    {
        value: 'KeyQ',
        label: 'KeyQ - Q'
    },
    {
        value: 'KeyR',
        label: 'KeyR - R'
    },
    {
        value: 'KeyS',
        label: 'KeyS - S'
    },
    {
        value: 'KeyT',
        label: 'KeyT - T'
    },
    {
        value: 'KeyU',
        label: 'KeyU - U'
    },
    {
        value: 'KeyV',
        label: 'KeyV - V'
    },
    {
        value: 'KeyW',
        label: 'KeyW - W'
    },
    {
        value: 'KeyX',
        label: 'KeyX - X'
    },
    {
        value: 'KeyY',
        label: 'KeyY - Y'
    },
    {
        value: 'KeyZ',
        label: 'KeyZ - Z'
    },
    {
        value: 'MetaLeft',
        label: 'MetaLeft - 左元键'
    },
    {
        value: 'MetaRight',
        label: 'MetaRight - 右元键'
    },
    {
        value: 'ContextMenu',
        label: 'ContextMenu - 上下文菜单'
    },
    {
        value: 'NumpadMultiply',
        label: 'NumpadMultiply - 小键盘乘号'
    },
    {
        value: 'NumpadAdd',
        label: 'NumpadAdd - 小键盘加号'
    },
    {
        value: 'NumpadSubtract',
        label: 'NumpadSubtract - 小键盘减号'
    },
    {
        value: 'NumpadDivide',
        label: 'NumpadDivide - 小键盘除号'
    },
    {
        value: 'F1',
        label: 'F1 - 功能键1'
    },
    {
        value: 'F2',
        label: 'F2 - 功能键2'
    },
    {
        value: 'F3',
        label: 'F3 - 功能键3'
    },
    {
        value: 'F4',
        label: 'F4 - 功能键4'
    },
    {
        value: 'F5',
        label: 'F5 - 功能键5'
    },
    {
        value: 'F6',
        label: 'F6 - 功能键6'
    },
    {
        value: 'F7',
        label: 'F7 - 功能键7'
    },
    {
        value: 'F8',
        label: 'F8 - 功能键8'
    },
    {
        value: 'F9',
        label: 'F9 - 功能键9'
    },
    {
        value: 'F10',
        label: 'F10 - 功能键10'
    },
    {
        value: 'F11',
        label: 'F11 - 功能键11'
    },
    {
        value: 'F12',
        label: 'F12 - 功能键12'
    },
    {
        value: 'F13',
        label: 'F13 - 功能键13'
    },
    {
        value: 'F14',
        label: 'F14 - 功能键14'
    },
    {
        value: 'F15',
        label: 'F15 - 功能键15'
    },
    {
        value: 'F16',
        label: 'F16 - 功能键16'
    },
    {
        value: 'F17',
        label: 'F17 - 功能键17'
    },
    {
        value: 'F18',
        label: 'F18 - 功能键18'
    },
    {
        value: 'F19',
        label: 'F19 - 功能键19'
    },
    {
        value: 'F20',
        label: 'F20 - 功能键20'
    },
    {
        value: 'F21',
        label: 'F21 - 功能键21'
    },
    {
        value: 'F22',
        label: 'F22 - 功能键22'
    },
    {
        value: 'F23',
        label: 'F23 - 功能键23'
    },
    {
        value: 'F24',
        label: 'F24 - 功能键24'
    },
    {
        value: 'NumLock',
        label: 'NumLock - 数字锁定'
    },
    {
        value: 'ScrollLock',
        label: 'ScrollLock - 滚动锁定'
    },
    {
        value: 'AudioVolumeMute',
        label: 'AudioVolumeMute - 静音'
    },
    {
        value: 'AudioVolumeDown',
        label: 'AudioVolumeDown - 音量减'
    },
    {
        value: 'AudioVolumeUp',
        label: 'AudioVolumeUp - 音量增'
    },
    {
        value: 'MediaTrackNext',
        label: 'MediaTrackNext - 下一曲'
    },
    {
        value: 'MediaTrackPrevious',
        label: 'MediaTrackPrevious - 上一曲'
    },
    {
        value: 'MediaStop',
        label: 'MediaStop - 停止播放'
    },
    {
        value: 'MediaPlayPause',
        label: 'MediaPlayPause - 播放/暂停'
    },
    {
        value: 'Semicolon',
        label: 'Semicolon - 分号'
    },
    {
        value: 'Equal',
        label: 'Equal - 等号'
    },
    {
        value: 'NumpadEqual',
        label: 'NumpadEqual - 小键盘等号'
    },
    {
        value: 'Comma',
        label: 'Comma - 逗号'
    },
    {
        value: 'Minus',
        label: 'Minus - 减号'
    },
    {
        value: 'Period',
        label: 'Period - 句点'
    },
    {
        value: 'Slash',
        label: 'Slash - 斜线'
    },
    {
        value: 'Backquote',
        label: 'Backquote - 反引号'
    },
    {
        value: 'BracketLeft',
        label: 'BracketLeft - 左方括号'
    },
    {
        value: 'Backslash',
        label: 'Backslash - 反斜杠'
    },
    {
        value: 'BracketRight',
        label: 'BracketRight - 右方括号'
    },
    {
        value: 'Quote',
        label: 'Quote - 引号'
    },
    {
        value: 'AltGraph',
        label: 'AltGraph - AltGraph'
    },
    {
        value: 'Props',
        label: 'Props - 属性'
    },
    {
        value: 'Cancel',
        label: 'Cancel - 取消'
    },
    {
        value: 'Clear',
        label: 'Clear - 清除'
    },
    {
        value: 'Shift',
        label: 'Shift - 移位'
    },
    {
        value: 'Control',
        label: 'Control - 控制'
    },
    {
        value: 'Alt',
        label: 'Alt - Alt'
    },
    {
        value: 'Accept',
        label: 'Accept - 接受'
    },
    {
        value: 'ModeChange',
        label: 'ModeChange - 模式改变'
    },
    {
        value: ' ',
        label: '  - 空格'
    },
    {
        value: 'Print',
        label: 'Print - 打印'
    },
    {
        value: 'Execute',
        label: 'Execute - 执行'
    },
    {
        value: '\u0000',
        label: '\u0000 - 空字符'
    },
    {
        value: 'a',
        label: 'a - a'
    },
    {
        value: 'b',
        label: 'b - b'
    },
    {
        value: 'c',
        label: 'c - c'
    },
    {
        value: 'd',
        label: 'd - d'
    },
    {
        value: 'e',
        label: 'e - e'
    },
    {
        value: 'f',
        label: 'f - f'
    },
    {
        value: 'g',
        label: 'g - g'
    },
    {
        value: 'h',
        label: 'h - h'
    },
    {
        value: 'i',
        label: 'i - i'
    },
    {
        value: 'j',
        label: 'j - j'
    },
    {
        value: 'k',
        label: 'k - k'
    },
    {
        value: 'l',
        label: 'l - l'
    },
    {
        value: 'm',
        label: 'm - m'
    },
    {
        value: 'n',
        label: 'n - n'
    },
    {
        value: 'o',
        label: 'o - o'
    },
    {
        value: 'p',
        label: 'p - p'
    },
    {
        value: 'q',
        label: 'q - q'
    },
    {
        value: 'r',
        label: 'r - r'
    },
    {
        value: 's',
        label: 's - s'
    },
    {
        value: 't',
        label: 't - t'
    },
    {
        value: 'u',
        label: 'u - u'
    },
    {
        value: 'v',
        label: 'v - v'
    },
    {
        value: 'w',
        label: 'w - w'
    },
    {
        value: 'x',
        label: 'x - x'
    },
    {
        value: 'y',
        label: 'y - y'
    },
    {
        value: 'z',
        label: 'z - z'
    },
    {
        value: 'Meta',
        label: 'Meta - 元键'
    },
    {
        value: '*',
        label: '* - 乘号'
    },
    {
        value: '+',
        label: '+ - 加号'
    },
    {
        value: '-',
        label: '- - 减号'
    },
    {
        value: '/',
        label: '/ - 除号'
    },
    {
        value: ';',
        label: '; - 分号'
    },
    {
        value: '=',
        label: '= - 等号'
    },
    {
        value: ',',
        label: ', - 逗号'
    },
    {
        value: '.',
        label: '. - 句点'
    },
    {
        value: '`',
        label: '` - 反引号'
    },
    {
        value: '[',
        label: '[ - 左方括号'
    },
    {
        value: '\\',
        label: '\\ - 反斜杠'
    },
    {
        value: ']',
        label: '] - 右方括号'
    },
    {
        value: "'",
        label: "' - 引号"
    },
    {
        value: 'Attn',
        label: 'Attn - 注意'
    },
    {
        value: 'CrSel',
        label: 'CrSel - CrSel'
    },
    {
        value: 'ExSel',
        label: 'ExSel - ExSel'
    },
    {
        value: 'EraseEof',
        label: 'EraseEof - EraseEof'
    },
    {
        value: 'Play',
        label: 'Play - 播放'
    },
    {
        value: 'ZoomOut',
        label: 'ZoomOut - 缩小'
    },
    {
        value: ')',
        label: ') - 右括号'
    },
    {
        value: '!',
        label: '! - 感叹号'
    },
    {
        value: '@',
        label: '@ - at 符号'
    },
    {
        value: '#',
        label: '# - 井号'
    },
    {
        value: '$',
        label: '$ - 美元符号'
    },
    {
        value: '%',
        label: '% - 百分号'
    },
    {
        value: '^',
        label: '^ - 脱字号'
    },
    {
        value: '&',
        label: '& - 与号'
    },
    {
        value: '(',
        label: '( - 左括号'
    },
    {
        value: 'A',
        label: 'A - A'
    },
    {
        value: 'B',
        label: 'B - B'
    },
    {
        value: 'C',
        label: 'C - C'
    },
    {
        value: 'D',
        label: 'D - D'
    },
    {
        value: 'E',
        label: 'E - E'
    },
    {
        value: 'F',
        label: 'F - F'
    },
    {
        value: 'G',
        label: 'G - G'
    },
    {
        value: 'H',
        label: 'H - H'
    },
    {
        value: 'I',
        label: 'I - I'
    },
    {
        value: 'J',
        label: 'J - J'
    },
    {
        value: 'K',
        label: 'K - K'
    },
    {
        value: 'L',
        label: 'L - L'
    },
    {
        value: 'M',
        label: 'M - M'
    },
    {
        value: 'N',
        label: 'N - N'
    },
    {
        value: 'O',
        label: 'O - O'
    },
    {
        value: 'P',
        label: 'P - P'
    },
    {
        value: 'Q',
        label: 'Q - Q'
    },
    {
        value: 'R',
        label: 'R - R'
    },
    {
        value: 'S',
        label: 'S - S'
    },
    {
        value: 'T',
        label: 'T - T'
    },
    {
        value: 'U',
        label: 'U - U'
    },
    {
        value: 'V',
        label: 'V - V'
    },
    {
        value: 'W',
        label: 'W - W'
    },
    {
        value: 'X',
        label: 'X - X'
    },
    {
        value: 'Y',
        label: 'Y - Y'
    },
    {
        value: 'Z',
        label: 'Z - Z'
    },
    {
        value: ':',
        label: ': - 冒号'
    },
    {
        value: '<',
        label: '< - 小于号'
    },
    {
        value: '_',
        label: '_ - 下划线'
    },
    {
        value: '>',
        label: '> - 大于号'
    },
    {
        value: '?',
        label: '? - 问号'
    },
    {
        value: '~',
        label: '~ - 波浪线'
    },
    {
        value: '{',
        label: '{ - 左花括号'
    },
    {
        value: '|',
        label: '| - 竖线'
    },
    {
        value: '}',
        label: '} - 右花括号'
    },
    {
        value: '"',
        label: '" - 双引号'
    },
    {
        value: 'SoftLeft',
        label: 'SoftLeft - 软左键'
    },
    {
        value: 'SoftRight',
        label: 'SoftRight - 软右键'
    },
    {
        value: 'Camera',
        label: 'Camera - 相机'
    },
    {
        value: 'Call',
        label: 'Call - 呼叫'
    },
    {
        value: 'EndCall',
        label: 'EndCall - 结束呼叫'
    },
    {
        value: 'VolumeDown',
        label: 'VolumeDown - 音量减'
    },
    {
        value: 'VolumeUp',
        label: 'VolumeUp - 音量增'
    }
];
function getKeyCodeMap() {
    return exports.keyCodeMap;
}
